"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.patchDeployment = exports.deployK8s = void 0;
var k8sCmd = __importStar(require("./k8sCmd"));
var shell = __importStar(require("../utils/shell"));
/**
 *
 * 更新特定集群中，对应 deployment 的 pod，如果没有变化，也会通过打 patch 的方式，触发强制更新
 *
 * @param cluster ssh 时，target host 名，可以为 ip，也可以为 ssh config 中已配置的 host
 * @param dir 对应 host 中，k8s 文件目录
 * @param yml 想要更新 yaml 相对 k8s 文件目录的路径
 * @param deployment yaml 中 deployment 的名称
 * @param namespace yaml 中的 namespace
 */
function deployK8s(cluster, dir, yml, deployment, namespace) {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: 
                // TODO: 根据 dir 与 yml，读取 deployment，namespace 等信息
                return [4 /*yield*/, shell.execSSH(cluster, [
                        "cd " + dir,
                        k8sCmd.apply(yml),
                        k8sCmd.patch(namespace, deployment, k8sCmd.patchInfo()),
                    ])];
                case 1:
                    // TODO: 根据 dir 与 yml，读取 deployment，namespace 等信息
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    });
}
exports.deployK8s = deployK8s;
/**
 *
 * 更新特定集群中，特定 namespace 的 deployment，通过 patch 方式，触发 deployment 更新
 *
 * @param cluster ssh 时，target host 名，可以为 ip，也可以为 ssh config 中已配置的 host
 * @param deployment deployment 的名称
 * @param namespace deployment 对应的 namespace
 */
function patchDeployment(cluster, deployment, namespace) {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, shell.execSSH(cluster, [
                        k8sCmd.patch(namespace, deployment, k8sCmd.patchInfo()),
                    ])];
                case 1:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    });
}
exports.patchDeployment = patchDeployment;
