import { DockerRegistry } from "../config";
export declare class Docker {
    private registry;
    constructor(config: DockerRegistry);
    /**
     *
     * @param docker 构建出来带 registry，namespace 的镜像地址
     * @param dockerfile dockerfile 路径，如果是相对路径，应该以 node 执行位置为准
     * @param imageName 镜像名
     * @param tags 镜像 tag，可以为 string，单个 tag，或者多个 tag 名称
     * @param deleteAfter push 完后，是否删除本地镜像
     */
    buildAndPush(dockerfile: string, imageName: string, tags: string | string[], deleteAfter: boolean): Promise<void>;
    imageName(name: string, tag: string): string;
    build(dockerfile: string, name: string, tagName: string | string[]): Promise<void>;
    tag(name: string, originalTag: string, newTag: string): void;
    push(name: string, tags: string | string[]): Promise<void>;
    rmImage(name: string, tags: string | string[]): Promise<void>;
}
//# sourceMappingURL=docker.d.ts.map