"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Docker = void 0;
var shell = __importStar(require("../utils/shell"));
var path_1 = __importDefault(require("path"));
var Docker = /** @class */ (function () {
    function Docker(config) {
        this.registry = config;
    }
    /**
     *
     * @param docker 构建出来带 registry，namespace 的镜像地址
     * @param dockerfile dockerfile 路径，如果是相对路径，应该以 node 执行位置为准
     * @param imageName 镜像名
     * @param tags 镜像 tag，可以为 string，单个 tag，或者多个 tag 名称
     * @param deleteAfter push 完后，是否删除本地镜像
     */
    Docker.prototype.buildAndPush = function (dockerfile, imageName, tags, deleteAfter) {
        return __awaiter(this, void 0, void 0, function () {
            var tagTask;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (typeof tags === "string") {
                            tags = [tags];
                        }
                        return [4 /*yield*/, this.build(dockerfile, imageName, tags[0])];
                    case 1:
                        _a.sent();
                        tagTask = tags.filter(function (t) { return t !== tags[0]; }).map(function (t) { return __awaiter(_this, void 0, void 0, function () {
                            return __generator(this, function (_a) {
                                switch (_a.label) {
                                    case 0: return [4 /*yield*/, this.tag(imageName, tags[0], t)];
                                    case 1:
                                        _a.sent();
                                        return [2 /*return*/];
                                }
                            });
                        }); });
                        return [4 /*yield*/, Promise.all(tagTask)];
                    case 2:
                        _a.sent();
                        return [4 /*yield*/, this.push(imageName, tags)];
                    case 3:
                        _a.sent();
                        if (!deleteAfter) return [3 /*break*/, 5];
                        return [4 /*yield*/, this.rmImage(imageName, tags)];
                    case 4:
                        _a.sent();
                        _a.label = 5;
                    case 5: return [2 /*return*/];
                }
            });
        });
    };
    Docker.prototype.imageName = function (name, tag) {
        return this.registry.auth + "/" + this.registry.namespace + "/" + name + ":" + tag;
    };
    Docker.prototype.build = function (dockerfile, name, tagName) {
        return __awaiter(this, void 0, void 0, function () {
            var tagTask;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (typeof tagName === "string") {
                            tagName = [tagName];
                        }
                        // TODO: support run script in different work path
                        return [4 /*yield*/, shell.execInDir(path_1.default.dirname(dockerfile), "docker build --rm -f " + path_1.default.basename(dockerfile) + " -t " + this.imageName(name, tagName[0]) + " .")];
                    case 1:
                        // TODO: support run script in different work path
                        _a.sent();
                        tagTask = tagName.filter(function (t) { return t !== tagName[0]; }).map(function (t) { return __awaiter(_this, void 0, void 0, function () {
                            return __generator(this, function (_a) {
                                switch (_a.label) {
                                    case 0: return [4 /*yield*/, this.tag(name, tagName[0], t)];
                                    case 1:
                                        _a.sent();
                                        return [2 /*return*/];
                                }
                            });
                        }); });
                        return [4 /*yield*/, Promise.all(tagTask)];
                    case 2:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    Docker.prototype.tag = function (name, originalTag, newTag) {
        shell.execSync("docker tag " + this.imageName(name, originalTag) + " " + this.imageName(name, newTag));
    };
    Docker.prototype.push = function (name, tags) {
        return __awaiter(this, void 0, void 0, function () {
            var _i, tags_1, tag;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (typeof tags === "string") {
                            tags = [tags];
                        }
                        _i = 0, tags_1 = tags;
                        _a.label = 1;
                    case 1:
                        if (!(_i < tags_1.length)) return [3 /*break*/, 4];
                        tag = tags_1[_i];
                        return [4 /*yield*/, shell.exec("docker push " + this.imageName(name, tag))];
                    case 2:
                        _a.sent();
                        _a.label = 3;
                    case 3:
                        _i++;
                        return [3 /*break*/, 1];
                    case 4: return [2 /*return*/];
                }
            });
        });
    };
    Docker.prototype.rmImage = function (name, tags) {
        return __awaiter(this, void 0, void 0, function () {
            var _i, tags_2, tag;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (typeof tags === "string") {
                            tags = [tags];
                        }
                        _i = 0, tags_2 = tags;
                        _a.label = 1;
                    case 1:
                        if (!(_i < tags_2.length)) return [3 /*break*/, 4];
                        tag = tags_2[_i];
                        return [4 /*yield*/, shell.exec("docker rmi " + this.imageName(name, tag))];
                    case 2:
                        _a.sent();
                        _a.label = 3;
                    case 3:
                        _i++;
                        return [3 /*break*/, 1];
                    case 4: return [2 /*return*/];
                }
            });
        });
    };
    return Docker;
}());
exports.Docker = Docker;
